import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.Scanner;
import java.util.Set;


public class PassMan {

		private Map <String, Credentials> vault;
		private String[] masterPass;
		private File input = new File("passwords.txt");
		private Scanner scan;
		private PrintStream output;
		
		public PassMan()
		{
			vault = new HashMap<String, Credentials> ();
		}
		public PassMan(Map<String, Credentials> a)
		{
			vault = a;
		}
		public void readFile() throws FileNotFoundException
		{
			scan = new Scanner(input);
			masterPass = DesEncrypter.decodeAccount(scan.nextLine());
			while(scan.hasNext())
			{
				vault.put(scan.nextLine(), new Credentials(DesEncrypter.decodeAccount(scan.nextLine())));
			}
			scan.close();
		}
		public String[] getMasterPass()
		{
			return masterPass;
		}
		public void addSite(String website, String userID, String password) throws FileNotFoundException
		{
			vault.put(website, new Credentials(userID, password));
		}
		public void addSite(String website, Credentials credentials) throws FileNotFoundException
		{
			vault.put(website, credentials);
		}
		public void removeSite(String website) throws FileNotFoundException
		{
			vault.remove(website);
		}
		public void printToFile() throws FileNotFoundException
		{
			output = new PrintStream("passwords.txt");
			output.println(DesEncrypter.encodeAccount(masterPass[0], masterPass[1]));
			for(String websiteName : vault.keySet())
			{
				output.println(websiteName);
				output.println(DesEncrypter.encodeAccount(vault.get(websiteName).getUserId(), vault.get(websiteName).getPassword()));
			}
			output.close();
		}
		public Set<String> listAllSites()
		{
			
			return vault.keySet();
		}
		public Credentials getCredentials(String website)
		{
			Credentials required = null;
			for(String websiteName : vault.keySet())
			{
				if(website.equals(websiteName))
				{
					required = (vault.get(website));
				}
			}
			return required;
		}
		public Map<String, Credentials> getMap()
		{
			return vault;	
		}
}
